#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_game_battle_field.h"
#include "FileEncrypt.h"
std::auto_ptr<M_game_battle_field> M_game_battle_field::msSingleton(nullptr);

int M_game_battle_field::GetCount()
{
	return (int)mMapData.size();
}

const M_game_battle_fieldData* M_game_battle_field::GetData(int64_t ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int64_t, M_game_battle_fieldData>& M_game_battle_field::GetMapData()
{
	return mMapData;
}

void M_game_battle_field::Reload()
{
	mMapData.clear();
	Load();
}

void M_game_battle_field::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_game_battle_fieldData data;
		{
			int64_t temp = 0;
			const char* str = element->Attribute("ID");
			tinyxml2::XMLUtil::ToInt64(str, &temp);
			data.mID = temp;
		}
		{
			int64_t temp = 0;
			const char* str = element->Attribute("monster_id");
			tinyxml2::XMLUtil::ToInt64(str, &temp);
			data.mmonster_id = temp;
		}
		data.mscene_type = element->IntAttribute("scene_type");
		data.mweight = element->IntAttribute("weight");
		data.mmax_num = element->IntAttribute("max_num");
		{
			const char* kill_count = element->Attribute("kill_count");
			std::vector<std::string> veckill_count;
			boost::split(veckill_count, kill_count, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < veckill_count.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(veckill_count[i].c_str(), &temp))
				{
					data.mkill_count.push_back(temp);
				}
			}
		}
		data.maward_drop_prob = element->FloatAttribute("award_drop_prob");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_game_battle_field::Load()
{
	Load("../Config/M_game_battle_field.xml");
}

M_game_battle_field* M_game_battle_field::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_game_battle_field());
	}
	return msSingleton.get();
}
